package braze.com.brazepluginexample

import android.os.Bundle

import io.flutter.app.FlutterActivity
import io.flutter.plugins.GeneratedPluginRegistrant

import com.appboy.Appboy
import com.appboy.AppboyLifecycleCallbackListener
import com.appboy.models.IInAppMessage
import com.appboy.models.IInAppMessageImmersive
import com.appboy.models.MessageButton
import com.appboy.ui.inappmessage.AppboyInAppMessageManager
import com.appboy.ui.inappmessage.InAppMessageCloser
import com.appboy.ui.inappmessage.InAppMessageOperation
import com.appboy.ui.inappmessage.listeners.IInAppMessageManagerListener


import com.braze.brazeplugin.BrazePlugin

class MainActivity: FlutterActivity() {
  override fun onCreate(savedInstanceState: Bundle?) {
    super.onCreate(savedInstanceState)
    GeneratedPluginRegistrant.registerWith(this)
    this.getApplication().registerActivityLifecycleCallbacks(AppboyLifecycleCallbackListener())

    class BrazeInAppMessageManagerListener() : IInAppMessageManagerListener {
      override fun onInAppMessageReceived(inAppMessage: IInAppMessage): Boolean {
        return false
      }

      override fun beforeInAppMessageDisplayed(inAppMessage: IInAppMessage): InAppMessageOperation {
        BrazePlugin.processInAppMessage(inAppMessage)
        return InAppMessageOperation.DISPLAY_NOW
      }

      override fun onInAppMessageClicked(inAppMessage: IInAppMessage,
                                         inAppMessageCloser: InAppMessageCloser): Boolean {
        return false
      }

      override fun onInAppMessageButtonClicked(inAppMessage: IInAppMessage, button: MessageButton,
                                               inAppMessageCloser: InAppMessageCloser): Boolean {
        return false
      }

      override fun onInAppMessageDismissed(inAppMessage: IInAppMessage) {
      }
    }
    AppboyInAppMessageManager.getInstance().setCustomInAppMessageManagerListener(
        BrazeInAppMessageManagerListener())

    Appboy.getInstance(this).logCustomEvent("flutter_sample_opened")

  }
}
